
/* demo.c   EOUE Project, 1997 by Michael Mangelsdorf    */
/* THIS FILE IS PUBLIC DOMAIN.
   LEAVE THIS MESSAGE IN PLACE AS COURTESY TO THE AUTHOR */


#include <stdio.h>
#include <dos.h>
#include "eoue.h"

byte *seg1, *seg2, *emsframebase;
unsigned dosmemseg, emshandle, jstring[40];

unsigned j_resource [] = {
     0x242B,0x244A,0x2448,0x3441,0x3B7A,0x0000,0x2551,0x253D,
     0x2533,0x2573,0x2447,0x3B48,0x2424,0x3042,0x2424,0x0000,
     0x4E29,0x2446,0x3D71,0x242D,0x0000,0x2462,0x3D50,0x4D68,
     0x245E,0x2439,0x0000,0xFFFF
     };

void pause (char *text) {printf("\r\n%s (Press any key.)",text); getch();}


void main (void) {

 unsigned i,j;

   jtext=j_resource;

   eoue_init (1);
   pause ("DOS allocation test. ");

   /* allocate memory from DOS */
   if (dosalloc(0x2000,&dosmemseg)) {
       printf ("\r\nDOS allocation failed.");
       return;
   } else printf ("\r\n128k byte DOS-memory allocated for fonts.");

   pause("");

   /* de-allocate DOS memory blocks */
   if (dosdealloc (dosmemseg)) printf ("\r\nDOS de-allocation failed.");
   else printf ("\r\nNow de-allocated...");

   pause("EMS allocation test.");

   /* allocate two 64k blocks of EMS-memory */
   if (!testemm()) {
     if (!emsalloc(8,emsframebase,&emshandle)) {
       banksw(0,emshandle);      /*no SEGMENT wrap-around!! 1 seg dontwrk*/
       banksw(1,emshandle);
       printf ("\r\n128k EMS-memory allocated for demonstration.");

       pause("");

	/* de-allocate EMS-memory */
       if (emsdealloc(emshandle))
       printf ("\r\nCould not de-allocate EMS-memory.");
       else printf ("\r\nNow de-allocated...");

     } else printf ("\r\nNot enough EMS-memory available.");
   } else printf ("\r\nNo EMS-manager found.");

   pause("Changing into graphics mode.");

   /* change to 320x400x256 mode */
   if (set320x400(0,0)) {printf ("\r\nNo VGA found."); return;}

   c=15; fixprint (30,100,"Page flipping - Press any key",0,1);
   flipscreen(); c=1; ClrScr();

   c=15; fixprint (0,30,"EOUE",0,1);
   c=7;  fixprint (0,30,"     provides C-programmers access to",0,1);
	 fixprint (0,50,"320x400 graphics resolution, 256 colors.",0,1);

   for (i=0;i<32;i++) for (y=70;y<100;y++) {x=i+30; c=64+i; plot();}

   c=15; fixprint (0,160,"Display 8/16-pixel ASCII characters.",0,1);
   c=2;  fixprint (10,200,"Text can be displayed",0,0);
   c=14; fixprint (10,209,"in a variety of ways.",0,0);
   c=3;  fixprint (10,209,"in a variety of ways.",1,0);

   c=15; fixprint (0,240,"EOUE  requires *only* VGA compatibility.",0,1);
	 fixprint (0,260,"It's completely royalty-free and you are",0,1);
	 fixprint (0,280,"encouraged to use it in your own code!",0,1);
	 fixprint (0,300,"But the main thing is...",0,1);
   c=14; fixprint (180,360,"(Press any key)",0,0);

   getch(); overscan(1); flipscreen();  getch();
   c=1; ClrScr();
     c=15; fixprint (0,20,"EOUE provides an interface to Japanese",0,1);
	   fixprint (0,40,"language text processing.",0,1);
     c=7;  jprint (0,70,resource(1,jstring),0);
	   jprint (0,90,resource(2,jstring),0);

     c=15; fixprint (0,120,"Print romaji strings directly in kana!",0,1);
	   kanatransl ("korehaKATAKANAyo",jstring);
     c=15; jprint (0,140,jstring,0);

	   fixprint (0,170,"Use any kanji-capable editor supporting",0,1);
	   fixprint (0,190,"JIS to prepare string resources for easy",0,1);
	   fixprint (0,210,"use in your programs...",0,1);

	   fixprint (0,240,"EOUE  also helps the C-programmer with",0,1);
	   fixprint (0,260,"*fat* DOS/EMS allocations and goodies",0,1);
	   fixprint (0,280,"like reversible up/down scrolling...",0,1);
     c=14; fixprint (180,360,"(Press any key)",0,0);

   flipscreen(); c=1; ClrScr();

     c=15; fixprint (30,0,"Don't worry...",0,1);
	   fixprint (20,20,"- I'll be back -",0,1);
     c=7;  tategaki (250,50,resource(3,jstring),0);
	   tategaki (234,50,resource(4,jstring),0);
     c=15; fixprint (10,120,"(when you press a few keys)",0,1);

     getch(); flipscreen(); getch();
   c=1; chunkscroll_up_keep(1,0); flipscreen(); getch();
	chunkscroll_up_keep(1,0); flipscreen(); getch();
	chunkscroll_down_kept (1); flipscreen(); getch();
	chunkscroll_down_kept (1); flipscreen(); getch();

   /* return to 80x25 text mode */
   set8025c();
   pause("That's all.");
   eoue_exit();
}

